<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Vistas del sistema</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas ver, crear o emparentar una Vista?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="center">
        <v-card max-height="695" min-height="695">
          <v-toolbar color="grey" dark>
            <v-toolbar-title class="white--text">
              ARBOL DE VISTAS DE LA PLATAFORMA
            </v-toolbar-title>
          </v-toolbar>
          <v-row>
            <v-col cols="12" lg="4" md="4" sm="4" xl="4">
              <arbol-vistas
                ref="arbol-vistas"
                @noData="noData"
                v-model="vista"
              />
            </v-col>
            <v-divider vertical />
            <v-col cols="12" lg="8" md="8" sm="8" xl="8">
              <template v-if="renderComponent">
                <gestion-vista
                  @force-rerender="forceRerender"
                  :vista-in="vista"
                  :instanceTree="instanceTree"
                />
              </template>
            </v-col>
          </v-row>
        </v-card>
      </div>
    </div>
  </div>
</template>
<script>
import ArbolVistas from "@/views/secure/accesos/sistema/mapa-sitio/components/ArbolVistas.vue";
import GestionVista from "@/views/secure/accesos/sistema/mapa-sitio/vistas/components/GestionVista.vue";
export default {
  name: "Component-MapaSitio",
  components: {
    ArbolVistas,
    GestionVista,
  },
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Accesos",
          disabled: false,
          exact: true,
          to: {
            name: "accesos",
          },
        },
        {
          text: "Sistema",
          disabled: false,
          exact: true,
          to: {
            name: "accesos_sistema",
          },
        },
        {
          text: "Mapa de Sitio",
          disabled: true,
          exact: true,
        },
      ],
      renderComponent: false,
      vista: null,
      instanceTree: null,
    };
  },
  watch: {
    vista(val) {
      if (val) {
        this.forceRerender();
      }
    },
  },
  methods: {
    forceRerender() {
      this.renderComponent = false;
      this.$nextTick(() => {
        this.renderComponent = true;
      });
    },
    noData($event) {
      this.forceRerender();
    },
  },
  mounted() {
    this.instanceTree = this.$refs["arbol-vistas"].$refs.tree;
  },
};
</script>
